%%%% Analysis of DSD data
clear all;
close all;



PIAh=0;
PIAdp=0;
dl=0.1;


len=300;
d=0.08:0.08:8.1;
dd=0.08;
N0=8000;
for n=1:len

    dm0=2;
    lam=4./dm0;
    mu=0;%-0.0201.*lam.^2+0.902.*lam-1.718;
    nd=N0.*d.^mu.*exp(-lam.*d);
    [Z,Zdr,R,D0,Adp,Kdp,Rhohv,LWC,Re,Rc,Dm,Sigm,Ahh]= calc_Xband(d,nd);
    disd.Z(n,1)=Z;
    disd.Zp(n,1)=Z-PIAh;
    disd.Zdr(n,1)=Zdr;
    disd.Zdrp(n,1)=Zdr-PIAdp;
    disd.Kdp(n,1)=Kdp;
    disd.Rhohv(n,1)=Rhohv;
    disd.Rt(n,1)=R;
    disd.D0(n,1)=D0;
    disd.Ah(n,1)=Ahh;
    disd.Adp(n,1)=Adp;
    disd.W(n,1)=LWC;
    disd.Dmt(n,1)=Dm;
    disd.Sigm(n,1)=Sigm;
    disd.Re(n,1)=Re;
    disd.Rc(n,1)=Rc;
    disd.Ntt(n,1)=sum(nd.*dd);
    PIAh=2*dl*nansum(disd.Ah(1:n));
    PIAdp=2*dl*nansum(disd.Adp(1:n));
end
range=(1:len).*0.1; 
radar_Zh = disd.Z; % 
radar_Zdr = disd.Zdr; %
d=0.08:0.08:8.1;
PIAhc=0;
PIAdpc=0;
disd.Zp=disd.Zp+1.*randn(300,1);
disd.Zdrp=disd.Zdrp+0.2.*randn(300,1)
for model=1:2
    fprintf('\n... 000%%');
    for n=1:len
            z=disd.Zp(n)+PIAhc;
            zdr=disd.Zdrp(n)+PIAdpc;            
            [rain,D0,mu,lam,N0,Nt,lwc,sigm,Dm]= DSDretrieval_X(z,zdr,model);
            rad(model).rainf(n)=rain;
            rad(model).D0(n)=D0;
            rad(model).mu(n)=mu;
            rad(model).lamf(n)=lam;
            rad(model).N0f(n)=N0;
            rad(model).Ntf(n)=Nt;
            rad(model).lwcf(n)=lwc;
            rad(model).sigm(n)=sigm;
            rad(model).Dmf(n)=Dm;
       nd=N0.*d.^mu.*exp(-lam.*d);
    [Z,Zdr,R0f,D00f,Adpf(n),Kdpf,Rhohvf,LWC0f,Re0f,Rc0f,Dm0f,Sigm0f,Ahhf(n)]= calc_Xband(d,nd);
    rad(model).Zf(n)=Z;
    rad(model).Zdrf(n)=Zdr;
    PIAhc=nansum(Ahhf).*2.*dl;
    PIAdpc=nansum(Adpf).*2.*dl;
    fprintf('\b\b\b\b\b %3d%%',round(n));
    end
end
%backward
PIAhc=0;
PIAdpc=0;
;
for model=1:2
    fprintf('\n... 000%%');
    for n=len:-1:1
            z=disd.Zp(n)+PIAh-PIAhc;
            zdr=disd.Zdrp(n)+PIAdp-PIAdpc;            
            [rain,D0,mu,lam,N0,Nt,lwc,sigm,Dm]= DSDretrieval_X(z,zdr,model);
            rad(model).rainb(n)=rain;
            rad(model).D0(n)=D0;
            rad(model).mu(n)=mu;
            rad(model).lamb(n)=lam;
            rad(model).N0b(n)=N0;
            rad(model).Ntb(n)=Nt;
            rad(model).lwcb(n)=lwc;
            rad(model).sigm(n)=sigm;
            rad(model).Dmb(n)=Dm;
       nd=N0.*d.^mu.*exp(-lam.*d);
    [Zb,Zdrb,R0b,D00b,Adpb(n),Kdpb,Rhohvb,LWC0b,Re0b,Rc0b,Dm0b,Sigm0b,Ahhb(n)]= calc_Xband(d,nd);
    rad(model).Zb(n)=Zb;
    rad(model).Zdrb(n)=Zdrb;
    PIAhc=nansum(Ahhb).*2.*dl;
    PIAdpc=nansum(Adpb).*2.*dl;
    fprintf('\b\b\b\b\b %3d%%',round(n));
    end
end


%m=find(Ct'>100&Kdp>0.&Zdr>0&Kdp<10&R0>0.5);

% n=3


radar_Zh=disd.Zp;
radar_Zdr=disd.Zdrp;
x_limit=[0 30];
figure;
set(gcf,'Position',[500 500 400 500])
set(gcf,'PaperPositionMode','auto')
subplot(2,1,1)
plot(range,disd.Z,'--',range,radar_Zh,'-');%, radar_time,rad(1).Zf,'-.',radar_time,rad(1).Zb,':')
xlim(x_limit)
ylim([10 60])
ylabel('Z_H, dBZ')
legend('Intrinsic value','Simu. measurement',1)
%title('Reflectivity, Z_H (dBZ)')
subplot(2,1,2)
plot(range, disd.Zdr,'--',range,radar_Zdr,'-');%,radar_time,rad(1).Zdrf,'-.',radar_time,rad(1).Zdrb,':')
xlim(x_limit)
ylim([-4 4.])
xlabel('Range, km')
ylabel('Z_{DR}, dB')
%legend('Intrinsic value','Simu. Measurement',1)
%title('Differential reflectivity, Z_{DR} (dB)')
figure
set(gcf,'Position',[500 500 400 500])
set(gcf,'PaperPositionMode','auto')
subplot(3,1,1)
semilogy(range, disd.Rt,'--',range,rad(1).rainf,'-',range,rad(1).rainb,'-.')
xlim(x_limit)
ylim([1 300])
ylabel('R, mm hr^{-1}')

%legend('2DVD','Radar',1)
%title('Rainfall rate, R (mm hr^{-1})')
subplot(312)
plot(range, disd.Dmt,'--',range,rad(1).Dmf,'-',range,rad(1).Dmb,'-.')
xlim(x_limit)
ylim([0 4])
%xlabel('Time, UTC')
ylabel('D_{m}, mm')
legend('Truth','Forward','Backward',1)
%title('Median volume diameter, D_0 (mm)')
subplot(3,1,3)
semilogy(range, disd.Ntt,'--',range,rad(1).Ntf,'-',range,rad(1).Ntb,'-.')
xlim(x_limit)
ylim([100 10^5])
xlabel('Range, km')
ylabel('N_t, # m^{-3}')

