function [R,D0,mum,lam,N0,Nt,lwc,sigm,Dm]= retrieval_DSD_X(dBZ,ZDR,model)
%writer: simon
%date modified: 2014-5-24
%DSD retrieval, independant of wavelengh
%Dmax=8mm
%model=1: exponential DSD
%model=2; C-G DSD for Nanjing

%initialize
scattftn80=load('Xband93_SCTT_RAIN.dat');
d80=scattftn80(:,1);
bar=scattftn80(:,2).*1;   % is to convert to mm
bai=scattftn80(:,3).*1;
bbr=scattftn80(:,4).*1;
bbi=scattftn80(:,5).*1;
% foreward scattering
far=scattftn80(:,6).*1;
fai=scattftn80(:,7).*1;
fbr=scattftn80(:,8).*1;
fbi=scattftn80(:,9).*1;
bam=abs(bar+i.*bai);
bbm=abs(bbr+i.*bbi);
% fam=abs(far+i.*fai);
% fbm=abs(fbr+i.*fbi);
% faa=angle(fbr+i.*fai).*180./pi;
% fba=angle(fbr+i.*fbi).*180./pi;
% baa=angle(bar+i.*bai).*180./pi;
% bba=angle(-bbr-i.*bbi).*180./pi;

fh=bam;%%%% only use absolute value of scater amplitude
fv=bbm;
dd=d80(2)-d80(1);%????????????
Dmx=8;%fix the Dmax=8mm
%
phi=0;%standard divation of canting angles
phi2=(phi*pi/180)^2;

epr=55.49+j*37.84;  %% for X-band
K2=abs((epr-1)/(epr+2))^2;
wave=32.3;
%
v=polyval([-0.002362,0.07934,-0.9551,4.932,-0.1021],d80);%Brandes 2002

%
dl=0.1;%????????????
nIter=30/dl;%??0??????30,lambda
fp=-1;
lam1=1;


%step 1 iteration method for retrievaling lambda and mum
%step 2 find N0 for a specific lambda,mum,z
%@ Guifu Zhang 2001 IEEE transactions
zdr=10^(ZDR/10);%convert to linear
dbzdr=ZDR;
refl=10^(dBZ/10);
if (refl>=1&&zdr>=1)%????????????????DSD retrieval
    if (dbzdr<0.1)%use empirical relation
        lwc=nan;%refl*10.^(polyval([-0.0411 0.373 -1.439 -2.9694],dbzdr));  %??????????????empirical relation of paper 2;
        D0=nan;%polyval([0.0226 -0.0785 0.8225 0.5811],dbzdr);
        Dm=nan;
        mum=nan;
        lam=nan;
        N0=nan;
        Nt=nan;%refl*10.*(polyval([-0.0558 0.5388 -1.8846 0.994],dbzdr));
        R=nan;%refl*10.^(polyval([-0.0307 0.2768 -1.1138 -1.9406],dbzdr));
        sigm=nan;
        Nw=nan;
    else
        for istep=1:nIter%??????????
            flag=0;%????????????????????lambda??
            lam=istep*dl;
            switch (model)
                case 1
                    mum=0;
                case 2
                    mum=-0.0320*lam^2+1.0465*lam-2.0895;% C-G Nanjing 2014 2DVD
            end
            zh=0.0;%????
            zv=0.0;
            nd=d80.^mum.*exp(-lam*d80);
            nd(d80>Dmx-0.05)=0;%??????????????????????
            temp1=((1-2*phi2)*fh.^2+2*phi2*fh.*fv).*nd*dd;
            zh=sum(temp1);
            temp2=((1-2*phi2)*fv.^2+2*phi2*fh.*fv).*nd*dd;
            zv=sum(temp2);
            if zv==0;continue; end;
            zdr_c=zh/zv;
            fc=zdr-zdr_c;
            if (fc*fp<0)
                lam=lam1-abs(fc*dl/(fc-fp));%confirmed by Professor Zhang
                flag=1;
                break;
            else
                fp=fc;
                lam1=lam;
            end
        end
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %claculate rain microphysical characteristics
        if (flag==0)
            N0=nan;  %-99;
            mum=nan;  %-99;
            lam=nan;  %-99;
            D0=nan;  %-99;
            Dm=nan;  %-99;
            sigm=nan;  %-99;
            Nt=nan;  %-99;  %% 2.085*refl.*10.^(0.728*dbzdr.^2-2.066*dbzdr);
            lwc=nan;%5.589e-4*refl.*10.^(0.223*dbzdr.^2-1.124*dbzdr);    %% @@@@
            R=nan;%7.6e-3*refl.*10.^(0.164*dbzdr.^2-0.897*dbzdr);     %% @@@@
            Nw=nan;
            %             if(dbzdr<=0.35)
            %                 D0=0.717+1.479*dbzdr-0.725*dbzdr.^2+0.171*dbzdr.^3;   %% @@@@
            %             end
            
        else
            switch model
                case 1
                    mum=0; % exponential DSD
                case 2
                    mum=-0.0320*lam^2+1.0465*lam-2.0895;% C-G Nanjing 2014 2DVD
            end
            nd=d80.^mum.*exp(-lam.*d80);
            nd(d80>Dmx-0.05)=0;
            zh0=sum(((1-2*phi2)*fh.^2+2*phi2*fh.*fv).*nd*dd);
            N0=refl/(4*wave^4/(pi^4*K2))/zh0;
            %calc  R Dm
            R=6e-4*pi*sum(d80.^3.*v.*nd)*dd*N0;
            
            D4=sum(d80.^4.*nd)*dd;
            D3=sum(d80.^3.*nd)*dd;
            Dm=D4/D3;
            %%%% estimate the spectrum width       %% @@@@
            sigm2=sum((d80-Dm).^2.*nd.*d80.^3*dd);
            sigm=(sigm2./D3).^(0.5);
            %
            Nt=sum(nd*dd)*N0;
            lwc=1e-3*pi/6*D3*N0;
            Nw=4^4/pi*1000*lwc/Dm.^4;
            
            %%%% calculate the mean diameter D0
            nd=N0.*d80.^mum.*exp(-lam.*d80);%notice:this nd is different from past
            nd(d80>(Dmx-0.05))=0;   %% here the bin of Dmx is mm+1, not mm
            mtp1=sum(nd.*d80.^3*dd);
            mtp2=0;
            m=0;
            mas=0;
            masp=0;
            if (mtp1>0)
                while (mas<0.5)
                    masp=mtp2/mtp1;
                    m=m+1;
                    mtp2=mtp2+nd(m).*d80(m).^3*dd;
                    mas=mtp2/mtp1;
                end
                D0=d80(m+1)-(mas-0.5)/(mas-masp)*dd;
            else
                D0=0;
            end
        end
    end
else
    R=nan;  %-99;
    D0=nan;  %-99;
    Dm=nan;  %-99;
    mum=nan;  %-99;
    lam=nan;  %-99;
    N0=nan;  %-99;
    Nt=nan;  %-99;
    lwc=nan;   %% @@@@
    sigm=nan;   %% @@@@
    Nw=nan;
end








